"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_LOGGER = DEFAULT_LOGGER;
exports.default = void 0;

var _apolloLink = require("apollo-link");

var _language = require("graphql/language");

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-console: 0 */
function DEFAULT_LOGGER({
  operationName,
  query,
  variables
}) {
  console.log(_chalk.default.gray(`
==================== [apollo-link-log] START ==================
operationName: ${operationName || 'null'}

${query}
variables: ${JSON.stringify(variables, null, 2)}
==================== [apollo-link-log] END ====================
    `));
}

const createLogLink = ({
  logger = DEFAULT_LOGGER,
  enabled = true
} = {}) => new _apolloLink.ApolloLink((operation, forward) => forward(operation).map(result => {
  if (!enabled) return result;
  const {
    operationName,
    query,
    variables
  } = operation;
  logger({
    operationName,
    query: (0, _language.print)(query),
    variables,
    operation
  });
  return result;
}));

var _default = createLogLink;
exports.default = _default;